#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include "uart.h"
#include "global.h"
#include "isa.h"

#define XTAL_CPU       16000000 
#define UART_BAUD_RATE   500000 


int main(void)
{ 
	unsigned int c ;
	dw adresse;
    uart_init(UART_BAUD_SELECT(UART_BAUD_RATE, XTAL_CPU)); 

	sei(); 

	uart_puts_P("ISA Bus Ready");

	init_isa();

	for(;;)
		{c= uart_getc();
		if (c&UART_NO_DATA);
		else if (c==0)				//ISA Reset
			init_isa();
    	else if (c==1)
    		adresse.byte[0]=uart_get();
    	else if (c==2)
    		adresse.byte[1]=uart_get();
    	else if (c==3)
    		adresse.byte[2]=uart_get();
    	else if (c==4)
    		adresse.byte[3]=uart_get();
    	else if (c==5)
    		set_adress(adresse);
    	else if (c==6)
    		io_write(uart_get());
    	else if (c==7)
    		mem_write(uart_get());
    	else if (c==8)
    		uart_putc(io_read());
    	else if (c==9)
    		uart_putc(mem_read());
    	}
}

void delay (unsigned int us)		//Fr 16MHz kalibriert !
{   unsigned int i;
    for (i=0;i<us;i++)
    	{asm ("nop");
		asm ("nop");
		asm ("nop");
		asm ("nop");
		asm ("nop");
		asm ("nop");
		asm ("nop");
		asm ("nop");
		asm ("nop");}
}

unsigned char uart_get(void)
{unsigned int c;
	while ((c= uart_getc())&UART_NO_DATA);
	return (char)(c&255);
}
